SHOW DATABASES;

USE EMPLOYEESDB;

#SIMPLE WHERE CLAUSE
SELECT * FROM DEPARTMENTS WHERE DEPT_NAME = 'MARKETING';

SELECT * FROM SALARIES WHERE EMP_NO = 10001;

#No records found
SELECT * FROM DEPARTMENTS 
WHERE DEPT_NAME = 'APPLICATION DEVELOPMENT';

#WHERE WITH > OPERATOR
SELECT * FROM SALARIES WHERE SALARY > 155700;

#WHERE WITH < OPERATOR
SELECT * FROM SALARIES WHERE SALARY < 39000;

#WHERE CLAUSE WITH THE != OPERATOR
SELECT COUNT(*),TITLE FROM TITLES WHERE TITLE != 'STAFF'
GROUP BY TITLE;

# IN OPERATOR
SELECT COUNT(EMP_NO),TITLE FROM TITLES 
WHERE TITLE IN ('SENIOR ENGINEER', 'ENGINEER', 'ASSISTANT ENGINEER')
GROUP BY TITLE;

#NOT IN OPERATOR
SELECT COUNT(EMP_NO),TITLE FROM TITLES 
WHERE TITLE NOT IN ('SENIOR ENGINEER', 'ENGINEER', 'ASSISTANT ENGINEER')
GROUP BY TITLE;

#IN with Subquery
SELECT * FROM EMPLOYEES WHERE EMP_NO IN
(SELECT DISTINCT EMP_NO FROM TITLES WHERE TITLE IN ('Staff','Technique Leader'))
LIMIT 20;

# WHERE WITH AND
SELECT DISTINCT EMP_NO FROM SALARIES 
WHERE SALARY < 45000 AND SALARY >= 39000
LIMIT 20;

# WHERE WITH OR 
SELECT COUNT(*),DEPT_NO FROM DEPT_EMP 
WHERE DEPT_NO = 'D002' OR DEPT_NO = 'D008' 
GROUP BY DEPT_NO;

#LIKE OPERATOR
SELECT * FROM EMPLOYEES 
WHERE HIRE_DATE LIKE '1999%'
AND GENDER = 'F'
LIMIT 20;


#EXISTS
SELECT * FROM EMPLOYEES WHERE 
EXISTS 
(SELECT 1 
FROM TITLES2);

#Exists
SELECT * FROM EMPLOYEES WHERE 
EXISTS 
(SELECT 1 
FROM TITLES)
LIMIT 20;


#Not Exists
SELECT * FROM EMPLOYEES WHERE 
NOT EXISTS 
(SELECT 1 
FROM TITLES2)
LIMIT 20;

#Not Exists
SELECT * FROM EMPLOYEES WHERE 
NOT EXISTS 
(SELECT 1 
FROM TITLES);


#IS NULL
SELECT * FROM DEPT_EMP WHERE to_DATE IS NULL;

#Where with Update 
UPDATE DEPT_EMP SET TO_DATE = NULL
WHERE EMP_NO =10010 AND DEPT_NO = 'D006';


#WHERE USING MULTIPLE TABLES
SELECT E.EMP_NO,E.FIRST_NAME,E.LAST_NAME,E.GENDER,D.DEPT_NAME,T.TITLE,S.SALARY
FROM EMPLOYEES E, DEPT_EMP DM,DEPARTMENTS D,SALARIES S,TITLES T
WHERE E.EMP_NO = DM.EMP_NO
AND DM.DEPT_NO = D.DEPT_NO
AND E.EMP_NO = S.EMP_NO
AND E.EMP_NO = T.EMP_NO
AND DM.TO_DATE = '9999-01-01'
AND S.TO_DATE = '9999-01-01'
AND T.TITLE='ENGINEER'
LIMIT 15;


